!!NVgp4.0

# geometry prgram recursively subdividing a triangle

PRIMITIVE_IN TRIANGLES;
PRIMITIVE_OUT TRIANGLE_STRIP;
VERTICES_OUT 256;

#PARAM maxdepth = program.local[0];
PARAM maxdepth = 4;
TEMP v0, v1, v2;
TEMP m0, m1, m2;
TEMP stack[256];
INT TEMP sptr;
TEMP depth, tmp;

MOV.U sptr.x, 0;
MOV depth.x, 0;

# push verts onto stack
MOV stack[sptr.x], vertex[0].position;
MOV stack[sptr.x+1], vertex[1].position;
MOV stack[sptr.x+2], vertex[2].position;
MOV stack[sptr.x+3], depth;
ADD.U sptr.x, sptr.x, 4;

CAL SUBDIV;
RET;

SUBDIV:

# pop verts off stack
ADD.U sptr.x, sptr, -4;
MOV v0, stack[sptr.x];
MOV v1, stack[sptr.x+1];
MOV v2, stack[sptr.x+2];
MOV depth, stack[sptr.x+3];

# check recursion depth
ADD depth.x, depth, 1;
ADD.CC tmp.x, maxdepth, -depth.x;

IF LE.x;

# output tri
MOV result.position, v0; EMIT;
MOV result.position, v1; EMIT;
MOV result.position, v2; EMIT;
ENDPRIM;

ELSE;

# compute midpoints
ADD m0, v0, v1;
MUL m0, m0, 0.5;
ADD m1, v1, v2;
MUL m1, m1, 0.5;
ADD m2, v2, v0;
MUL m2, m2, 0.5;

# push new tris on stack
MOV stack[sptr.x], v0;
MOV stack[sptr.x+1], m2;
MOV stack[sptr.x+2], m0;
MOV stack[sptr.x+3], depth;
ADD.U sptr.x, sptr.x, 4;

MOV stack[sptr.x], m2;
MOV stack[sptr.x+1], m1;
MOV stack[sptr.x+2], m0;
MOV stack[sptr.x+3], depth;
ADD.U sptr.x, sptr.x, 4;

MOV stack[sptr.x], m0;
MOV stack[sptr.x+1], m1;
MOV stack[sptr.x+2], v1;
MOV stack[sptr.x+3], depth;
ADD.U sptr.x, sptr.x, 4;

MOV stack[sptr.x], m2;
MOV stack[sptr.x+1], v2;
MOV stack[sptr.x+2], m1;
MOV stack[sptr.x+3], depth;
ADD.U sptr.x, sptr.x, 4;

# call recursively
CAL SUBDIV;
CAL SUBDIV;
CAL SUBDIV;
CAL SUBDIV;

ENDIF;

RET;
END